
#ifdef COMPILED
#define STORAGE double
#else
#define STORAGE
#endif


#define Q_PLUS_Q_EQ \
C_S = L_S + R_S; \
C_A = L_A + R_A; \
C_B = L_B + R_B; \
C_C = L_C + R_C;


#define Q_PLUS_S_EQ \
C_S = L_S + R_S; \
C_A = L_A; \
C_B = L_B; \
C_C = L_C;


#define Z_PLUS_Z_EQ \
C_S = L_S + R_S; \
C_A = L_A + R_A;


#define Z_PLUS_S_EQ \
C_S = L_S + R_S; \
C_A = L_A;


#define S_PLUS_S_EQ C_S = L_S + R_S;


#define Q_MINUS_Q_EQ C_S = L_S - R_S; \
C_A = L_A - R_A; \
C_B = L_B - R_B; \
C_C = L_C - R_C;


#define Q_MINUS_S_EQ C_S = L_S - R_S; \
C_A = L_A; \
C_B = L_B; \
C_C = L_C;


#define S_MINUS_Q_EQ C_S = L_S - R_S; \
C_A = -R_A; \
C_B = -R_B; \
C_C = -R_C;


#define Z_MINUS_Z_EQ C_S = L_S - R_S; \
C_A = L_A - R_A;


#define Z_MINUS_S_EQ C_S = L_S - R_S; \
C_A = L_A;


#define S_MINUS_Z_EQ C_S = L_S - R_S; \
C_A = -R_A;


#define S_MINUS_S_EQ C_S = L_S - R_S;


#define Q_TIMES_Q_EQ C_S = L_S*R_S - L_A*R_A - L_B*R_B - L_C*R_C; \
C_A = L_A*R_S + L_S*R_A + L_B*R_C - L_C*R_B; \
C_B = L_B*R_S + L_S*R_B + L_C*R_A - L_A*R_C; \
C_C = L_C*R_S + L_S*R_C + L_A*R_B - L_B*R_A;


#define Q_TIMES_Q_NC_EQ C_S = L_S*R_S - L_A*R_A - L_B*R_B - L_C*R_C; \
C_A = L_A*R_S + L_S*R_A; \
C_B = L_B*R_S + L_S*R_B; \
C_C = L_C*R_S + L_S*R_C;


#define Q_TIMES_S_EQ C_S = R_S*L_S; \
C_A = R_S*L_A; \
C_B = R_S*L_B; \
C_C = R_S*L_C;


#define Z_TIMES_Z_EQ C_S = L_S*R_S - L_A*R_A; \
C_A = L_A*R_S + L_S*R_A;


#define Z_TIMES_S_EQ C_S = R_S*L_S; \
C_A = R_S*L_A;


#define S_TIMES_S_EQ C_S = L_S*R_S;


#define Q_DIV_Q_EQ STORAGE mag_of_p_squared = R_S*R_S + R_A*R_A + R_B*R_B + R_C*R_C; \
C_S = (L_S*R_S + L_A*R_A + L_B*R_B + L_C*R_C)/mag_of_p_squared; \
C_A = (L_A*R_S - L_S*R_A - L_B*R_C + L_C*R_B)/mag_of_p_squared; \
C_B = (L_B*R_S - L_S*R_B - L_C*R_A + L_A*R_C)/mag_of_p_squared; \
C_C = (L_C*R_S - L_S*R_C - L_A*R_B + L_B*R_A)/mag_of_p_squared;

#define S_DIV_Q_EQ STORAGE mag_of_p_squared = R_S*R_S + R_A*R_A + R_B*R_B + R_C*R_C; \
C_S =  L_S*R_S/mag_of_p_squared; \
C_A = -L_S*R_A/mag_of_p_squared; \
C_B = -L_S*R_B/mag_of_p_squared; \
C_C = -L_S*R_C/mag_of_p_squared;

#define Q_DIV_S_EQ C_S = L_S/R_S; \
C_A = L_A/R_S; \
C_B = L_B/R_S; \
C_C = L_C/R_S;

#define Z_DIV_Z_EQ STORAGE mag_of_p_squared = R_S*R_S + R_A*R_A; \
C_S = (L_S*R_S + L_A*R_A)/mag_of_p_squared; \
C_A = (L_A*R_S - L_S*R_A)/mag_of_p_squared;

#define S_DIV_Z_EQ STORAGE mag_of_p_squared = R_S*R_S + R_A*R_A; \
C_S =  L_S*R_S/mag_of_p_squared; \
C_A = -L_S*R_A/mag_of_p_squared;

#define Z_DIV_S_EQ C_S = L_S/R_S; \
C_A = L_A/R_S;

#define S_DIV_S_EQ C_S = L_S/R_S;

#define Q_EXP_S_EVEN_EQ C_S = L_S*L_S - L_A*L_A - L_B*L_B - L_C*L_C; \
C_A = 2*L_A*L_S; \
C_B = 2*L_B*L_S; \
C_C = 2*L_C*L_S;

#define S_EXP_Q_EQ STORAGE log_of_base = log(L_S); \
STORAGE coef = pow(L_S, R_S); \
C_S = coef* \
(cos(log_of_base*R_A)*cos(log_of_base*R_B)*cos(log_of_base*R_C) - \
 sin(log_of_base*R_A)*sin(log_of_base*R_B)*sin(log_of_base*R_C)); \
 \
C_A = coef* \
(cos(log_of_base*R_A)*sin(log_of_base*R_B)*sin(log_of_base*R_C) + \
 sin(log_of_base*R_A)*cos(log_of_base*R_B)*cos(log_of_base*R_C)); \
 \
C_B = coef* \
(cos(log_of_base*R_A)*sin(log_of_base*R_B)*cos(log_of_base*R_C) - \
 sin(log_of_base*R_A)*cos(log_of_base*R_B)*sin(log_of_base*R_C)); \
 \
C_C = coef* \
(cos(log_of_base*R_A)*cos(log_of_base*R_B)*sin(log_of_base*R_C) + \
 sin(log_of_base*R_A)*sin(log_of_base*R_B)*cos(log_of_base*R_C));

#define Z_EXP_S_EVEN_EQ C_S = L_S*L_S - L_A*L_A; \
C_A = 2*L_A*L_S;


#define S_EXP_Z_EQ STORAGE log_of_base = log(L_S); \
STORAGE coef = pow(L_S, R_S); \
C_S = coef * cos(log_of_base*R_A); \
C_A = coef * sin(log_of_base*R_A);

#define S_EXP_S_EQ C_S = pow(L_S, R_S);

#define RE_Q_EQ C_S = L_S;

#define IM_I_Q_EQ C_S = L_A;

#define IM_J_Q_EQ C_S = L_B;

#define IM_K_Q_EQ C_S = L_C;

#define ABS_S_EQ C_S = fabs(L_S);

#define ABS_Q_EQ C_S = sqrt(L_S*L_S + L_A*L_A + L_B*L_B + L_C*L_C);

#define ABS_Z_EQ C_S = sqrt(L_S*L_S + L_A*L_A);

#define SIN_Z_EQ C_S = sin(L_S)*cosh(L_A); \
C_A = cos(L_S)*sinh(L_A);


#define COS_Z_EQ C_S = cos(L_S)*cosh(L_A); \
C_A = sin(L_S)*sinh(L_A);


#define TAN_Z_EQ t1 = tan(L_S); t2 = tanh(L_A); t3 = t1*t1; t4 = t2*t2; t5 = 1+t3*t4; C_S = t1*(1-t4)/t5; C_A = t2*(1-t3)/t5;

#define SINH_Z_EQ C_S = sinh(L_S)*cos(L_A); \
C_A = cosh(L_S)*sin(L_A);

#define COSH_Z_EQ C_S = cosh(L_S)*cos(L_A); \
C_A = sinh(L_S)*sin(L_A);

#define TANH_Z_EQ t1 = tanh(L_S); t2 = tan(L_A); t3 = t1*t1; t4 = t2*t2; t5 = 1+t3*t4; C_S = t1*(1+t4)/t5; C_A = t2*(1-t3)/t5;

#define LN_Z_EQ C_S = log(sqrt(L_S*L_S + L_A*L_A)); \
C_A = atan2(L_S, L_A);

#define LOG_Z_EQ C_S = log(sqrt(L_S*L_S + L_A*L_A))/log(R_S); \
C_A = atan2(L_S, L_A);
