// do not compile this file directly!! it is included by eq_table.cc
// This is an example of the swiss cheese approach first encountered with XaoS

SIGNATURE
{

    eq_table::Entry * curr;

    if(P->init_c_index != -1) {
	P->init_table[P->init_c_index]->vect[0] = v[0];
	P->init_table[P->init_c_index]->vect[1] = v[1];
	P->init_table[P->init_c_index]->vect[2] = v[2];
	P->init_table[P->init_c_index]->vect[3] = v[3];
    }

    if(P->init_needs_work) {

#define TABLE init_table
#define INIT init_first_work_necessary
#define END init_index_of_last_column
#include "iter.cc"

    } else if(P->init_c_index != P->init_index_of_last_column) {
#if 0
	memcpy(P->old_iterates[0]->vect, P->saved_init, sizeof(double)*4);
#else
	P->old_iterates[0]->vect[0] = P->saved_init[0];
	P->old_iterates[0]->vect[1] = P->saved_init[1];
	P->old_iterates[0]->vect[2] = P->saved_init[2];
	P->old_iterates[0]->vect[3] = P->saved_init[3];
#endif
    }

    for(int i = 1 ; i < P->num_iterates ; i++)
	memset(P->old_iterates[i]->vect, 0, sizeof(double)*4);    

    // try to combine this with one above at some point
    if(P->c_index != -1) {
	P->table[P->c_index]->vect[0] = v[0];
	P->table[P->c_index]->vect[1] = v[1];
	P->table[P->c_index]->vect[2] = v[2];
	P->table[P->c_index]->vect[3] = v[3];
    }

    int iter = 0;

    do {

#ifdef SOUND
	printf("%.20f %.20f\n", P->old_iterates[0]->vect[0],
  	       P->old_iterates[0]->vect[1]);
#else
#ifdef OUTPUT
	printf("%d: %.2f %.2f %.2f %.2f\n", iter, P->old_iterates[0]->vect[0],
  	       P->old_iterates[0]->vect[1], P->old_iterates[0]->vect[2], 
  	       P->old_iterates[0]->vect[3]);

	printf("  %.2f %.2f\n", P->mag(), P->max_val);
#endif
#endif

#define TABLE table
#define INIT first_work_necessary
#define END index_of_last_column
#include "iter.cc"

	for(int i = iter > P->num_iterates - 1 ? P->num_iterates - 1 : iter ;
	    i > 0 ; i--) {
	    P->old_iterates[i]->vect[0] = P->old_iterates[i-1]->vect[0];
	    P->old_iterates[i]->vect[1] = P->old_iterates[i-1]->vect[1];
	    P->old_iterates[i]->vect[2] = P->old_iterates[i-1]->vect[2];
	    P->old_iterates[i]->vect[3] = P->old_iterates[i-1]->vect[3];
	}
	
	P->old_iterates[0]->vect[0] = P->table[P->index_of_last_column]->vect[0];
	P->old_iterates[0]->vect[1] = P->table[P->index_of_last_column]->vect[1];
	P->old_iterates[0]->vect[2] = P->table[P->index_of_last_column]->vect[2];
	P->old_iterates[0]->vect[3] = P->table[P->index_of_last_column]->vect[3];

    } while(++iter < P->max_iter && 
	    (P->btest_greater ? (P->mag() > P->max_val) : // newton
               	                (P->mag() < P->max_val)));// normal

#ifdef SOUND
	printf("%.20f %.20f\n", P->old_iterates[0]->vect[0],
  	       P->old_iterates[0]->vect[1]);

#else    

#ifdef OUTPUT
    printf("%d: %.2f %.2f %.2f %.2f\n", iter, P->old_iterates[0]->vect[0],
  	   P->old_iterates[0]->vect[1], P->old_iterates[0]->vect[2], 
 	   P->old_iterates[0]->vect[3]);

    printf("  %.2f\n", P->mag());
#endif
#endif
     RETVALS
}
#undef SIGNATURE
#undef RETVALS
#undef P



