 
%{
#include "expr_tree.h"
#include "quatdefs.h"
expr_ref tree_top;
%}


%token '^' '*' '/' '+' '-' TOK_LIT_QUAT TOK_LIT_COMPLEX 'q' 'z' 'i' 'j' 'k' 'e' TOK_LIT_PI '(' ')' TOK_LIT_SCALAR TOK_RE TOK_IM_I TOK_IM_J TOK_IM_K TOK_SIN TOK_COS TOK_TAN TOK_SINH TOK_COSH TOK_TANH TOK_LN TOK_LOG

%left ')'
%left '-' '+'
%left '*' '/'
%right '^'

%start s

%%

s:  quat_expr                       { tree_top = $1->post_process(); }

quat_expr:  
         '(' quat_expr ')'           { $$ = $2; }
       | quat_expr '^' quat_expr     { $$ = $2->set_children($1, $3); } 
       | quat_expr '+' quat_expr     { $$ = $2->set_children($1, $3); } 
       | quat_expr '-' quat_expr     { $$ = $2->set_children($1, $3); } 
       | quat_expr '*' quat_expr     { $$ = $2->set_children($1, $3); } 
       | quat_expr '/' quat_expr     { $$ = $2->set_children($1, $3); } 
       | function '(' quat_expr ')'    { $$ = $1->set_child($3); }
       | TOK_LOG '_' quat_expr '(' quat_expr ')' { $$ = $1->set_children($3, $5); }
       | '|' quat_expr '|'           { $$ = $1->set_child($2); }
       | 'q'                         { $$ = $1; }
       | 'q' '_' subscript_expr      { $$ = $2->set_children($1, $3); } 
       | 'z'                         { $$ = $1; }
       | 'z' '_' subscript_expr      { $$ = $2->set_children($1, $3); } 
       | 'i'                         { $$ = $1; }
       | 'j'                         { $$ = $1; }
       | 'k'                         { $$ = $1; } 
       | 'c'                         { $$ = $1; }
       | TOK_LIT_QUAT                { $$ = $1; }
       | TOK_LIT_COMPLEX             { $$ = $1; }
       | TOK_LIT_SCALAR              { $$ = $1; }
       | TOK_LIT_PI                  { $$ = $1; }
       | 'e'                         { $$ = $1; }

function:
       TOK_RE    { $$ = $1; }
     | TOK_IM_I  { $$ = $1; }
     | TOK_IM_J  { $$ = $1; }
     | TOK_IM_K  { $$ = $1; }
     | TOK_SIN   { $$ = $1; }
     | TOK_COS   { $$ = $1; }
     | TOK_TAN   { $$ = $1; }
     | TOK_SINH  { $$ = $1; }
     | TOK_COSH  { $$ = $1; }
     | TOK_TANH  { $$ = $1; }
     | TOK_LN    { $$ = $1; }

subscript_expr:
       '(' paren_subscript_expr ')'      { $$ = $2; }
     | 'n'                               { $$ = $1; }

paren_subscript_expr:
      'n' '-' TOK_LIT_SCALAR          { $$ = $2->set_children($1, $3); }
    | 'n'                             { $$ = $1; }

%%

void yyerror(const char * message) {
    fprintf(stderr, message);
}

