 /* these are the operands in the equations.  
   First letter:  L is left operand
                  R is right operand
		  C is result
   Second letter: S is scalar part
                  A is i coefficient
		  B is j coefficient
                  C is k coefficient
   */
#include "equations.h"

#define L_S P->TABLE[larg]->vect[0]
#define L_A P->TABLE[larg]->vect[1]
#define L_B P->TABLE[larg]->vect[2]
#define L_C P->TABLE[larg]->vect[3]
 
#define R_S P->TABLE[rarg]->vect[0]
#define R_A P->TABLE[rarg]->vect[1]
#define R_B P->TABLE[rarg]->vect[2]
#define R_C P->TABLE[rarg]->vect[3]

#define C_S curr->vect[0]
#define C_A curr->vect[1]
#define C_B curr->vect[2]
#define C_C curr->vect[3]

for(int i = P->INIT ; i <= P->END ; i++) {
    curr = P->TABLE[i];

    int larg = curr->dep1;
    int rarg = curr->dep2;
    double log_of_base;
    double mag_of_p_squared;
    double coef;
    double t1, t2, t3, t4, t5;

    switch (curr->rule) {

    case Q_PLUS_Q: Q_PLUS_Q_EQ break;
    case Q_PLUS_S: Q_PLUS_S_EQ break;
    case Z_PLUS_Z: Z_PLUS_Z_EQ break;
    case Z_PLUS_S: Z_PLUS_S_EQ break;
    case S_PLUS_S: S_PLUS_S_EQ break;
    
    case Q_MINUS_Q: Q_MINUS_Q_EQ break;
    case Q_MINUS_S: Q_MINUS_S_EQ break;
    case S_MINUS_Q: S_MINUS_Q_EQ break;
    case Z_MINUS_Z: Z_MINUS_Z_EQ break;
    case Z_MINUS_S: Z_MINUS_S_EQ break;
    case S_MINUS_Z: S_MINUS_Z_EQ break;
    case S_MINUS_S: S_MINUS_S_EQ break;

    case Q_TIMES_Q: Q_TIMES_Q_EQ break;
    case Q_TIMES_Q_NC: Q_TIMES_Q_NC_EQ break;
    case Q_TIMES_S: Q_TIMES_S_EQ break;
    case Z_TIMES_Z: Z_TIMES_Z_EQ break;
    case Z_TIMES_S: Z_TIMES_S_EQ break;
    case S_TIMES_S: S_TIMES_S_EQ break;

    case Q_DIV_Q: Q_DIV_Q_EQ break;
    case S_DIV_Q: S_DIV_Q_EQ break;
    case Q_DIV_S: Q_DIV_S_EQ break;
    case Z_DIV_Z: Z_DIV_Z_EQ break;
    case S_DIV_Z: S_DIV_Z_EQ break;
    case Z_DIV_S: Z_DIV_S_EQ break;
    case S_DIV_S: S_DIV_S_EQ break;

    case Q_EXP_S_EVEN: Q_EXP_S_EVEN_EQ break;
    case S_EXP_Q: S_EXP_Q_EQ break;
    case Z_EXP_S_EVEN: Z_EXP_S_EVEN_EQ break;
    case S_EXP_Z: S_EXP_Z_EQ break;
    case S_EXP_S: S_EXP_S_EQ break;

    case RE_Q: RE_Q_EQ break;
    case IM_I_Q: IM_I_Q_EQ break;
    case IM_J_Q: IM_J_Q_EQ break;
    case IM_K_Q: IM_K_Q_EQ break;

    case ABS_S: ABS_S_EQ break;
    case ABS_Q: ABS_Q_EQ break;
    case ABS_Z: ABS_Z_EQ break;

    case SIN_Z: SIN_Z_EQ break;
    case COS_Z: COS_Z_EQ break;
    case TAN_Z: TAN_Z_EQ break;

    case SINH_Z: SINH_Z_EQ break;
    case COSH_Z: COSH_Z_EQ break;
    case TANH_Z: TANH_Z_EQ break;

    case LN_Z: LN_Z_EQ break;
    case LOG_Z: LOG_Z_EQ break;
    }
}
#undef TABLE
#undef INIT
#undef END
